'use strict';

/**
 *
 *
 * @author Zhong
 * @date 2019/1/25
 * @version
 */

import BaseController from "../../common/base/base_controller";
import progressiveFacade from "../facade/progressive_facade";
let config = require("../../../config/config.js");

class ProgressiveController extends BaseController{
    async main(request, response) {
        let progressiveLib = await progressiveFacade.findByCondition({},{data:0},false);
        let randerData = {
            title:'累进区间库',
            userAccount: request.session.managerData.username,
            userID: request.session.managerData.userID,
            progressiveLibs:progressiveLib,
            layout: 'maintain/common/html/layout'
        };
        response.render("maintain/progressive_lib/html/main", randerData);
    }
    async addLib(request, response){
        try {
            await progressiveFacade.addLib(request.body);
        }catch (error) {
            console.log(error);
        }
        response.redirect(request.headers.referer);
    }
    async findLib(request, response){
        let result={
            error:0
        };
        try {
            let data = request.body.data;
            data = JSON.parse(data);
            let conditions={'ID' : data.ID};
            let resultData = await progressiveFacade.findByCondition(conditions);
            result.data=resultData;
        }catch (err){
            console.log(err);
            result.error=1;
            result.message = err.message;
        }
        response.json(result);
    }
    async saveLib(request, response){
        let result={
            error:0
        };
        try {
            let data = request.body.data;
            data = JSON.parse(data);
            let resultData= await progressiveFacade.saveLib(data);
            result.data=resultData;
        }catch (err){
            console.log(err);
            result.error=1;
            result.message = err.message;
        }
        response.json(result);
    }
    async deleteLibByID(request,response){
        let result={
            error:0
        };
        try {
            let data = request.body.data;
            data = JSON.parse(data);
            let resultData= await progressiveFacade.deleteLibByID(data.ID);
            result.data=resultData;
        }catch (err){
            console.log(err);
            result.error=1;
            result.message = err.message;
        }
        response.json(result);
    }
    async edit(request,response){
        //先取出替换库信息：
        let libID = request.params.libID;
        let progressiveLib = await progressiveFacade.findByCondition({'ID':libID});
        if(progressiveLib){
            let randerData = {
                title:'累进区间库',
                mainURL:'/progressive/main',
                libName:progressiveLib.name,
                userAccount: request.session.managerData.username,
                userID: request.session.managerData.userID,
                progressiveList:JSON.stringify(progressiveLib.data),
                libID:libID,
                LicenseKey:config.getLicenseKey(process.env.NODE_ENV),
                layout: 'maintain/common/html/edit_layout'
            };
            response.render("maintain/progressive_lib/html/edit", randerData);
        }else {
            response.redirect(request.headers.referer);
        }
    }
}
export default ProgressiveController;